package com.cim.idm.service.Impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.cim.idm.dao.CostCenterDao;
import com.cim.idm.model.CostCenter;
import com.cim.idm.model.po.MaterialReceiveRequest;
import com.cim.idm.service.CostCenterService;
import com.cim.idm.wmspackage.materialpacking.management.data.MaterialPacking;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

@Service("CostCenterService")
@Slf4j
public class CostCenterServiceImpl implements CostCenterService {
    @Autowired
    private CostCenterDao costCenterDao;

    @Override
    public List<CostCenter> getCostCenter() {
        return costCenterDao.getCostCenter();
    }

    @Override
    public List<Map<String, Object>> getUserInfo() {
        return costCenterDao.getUserInfo();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateCareerAssistanceNew(JSONObject in) {
        MaterialReceiveRequest sl = JSON.toJavaObject(in, MaterialReceiveRequest.class);
        List<MaterialPacking> boxList = sl.getBoxList();
        String SALESHIPREQUESTNAME = sl.getSALESHIPREQUESTNAME();
        String SALESHIPREQUESTDETAILNAME = sl.getSALESHIPREQUESTDETAILNAME();
        String siteName = sl.getSiteName();
        // 借用人
        String career_ASSISTANCE = sl.getRemark();
        for (MaterialPacking materialPacking : boxList) {
            // 条码
            String materialPackingName = materialPacking.getMaterialPackingName();
            // 原销售订单号
            String saleshiprequestname = materialPacking.getSALESHIPREQUESTNAME();
            // 物料编号
            String materialSpecName = materialPacking.getMaterialSpecName();
            // 批次号
            String charge = materialPacking.getCharge();
            // 阶段
            String phase = materialPacking.getPHASE();
            // 客户
            String customno = materialPacking.getCUSTOMNO();
            // 过账状态
            String POSTSTATUS = "";
            if (StringUtils.isEmpty(saleshiprequestname) && StringUtils.isNotEmpty(SALESHIPREQUESTNAME)){
                POSTSTATUS = "0";
            } else if (StringUtils.isNotEmpty(saleshiprequestname) && StringUtils.isEmpty(SALESHIPREQUESTNAME)){
                POSTSTATUS = "1";
            } else if (StringUtils.isNotEmpty(saleshiprequestname) && StringUtils.isNotEmpty(SALESHIPREQUESTNAME)){
                POSTSTATUS = "2";
            }
            if (StringUtils.isEmpty(materialPacking.getCAREER_ASSISTANCE()) || materialPacking.getCAREER_ASSISTANCE().equals(career_ASSISTANCE)){
                // 更新
                costCenterDao.updatePacking(SALESHIPREQUESTNAME, SALESHIPREQUESTDETAILNAME, POSTSTATUS, materialPackingName);
            } else {
                // 新增
                costCenterDao.insertPackingChenk(SALESHIPREQUESTNAME, SALESHIPREQUESTDETAILNAME,
                        materialPackingName, siteName, materialSpecName, charge,phase,
                        customno, career_ASSISTANCE,POSTSTATUS);
            }
        }

    }
}
